# VoiceState - Discord Bot
This is a simple bot, tracking the mute state of members currently using the voice chat. The generated json files are named by the userId and contain just the mute state and no other information.

## Example
```
# https://discordbot.f-brinker.de/voice-state/states/userId123.json
{"state":"selfMuted"}
```

### Possible States
* active
* muted
* selfMuted

## Usage
* Add the Bot to your Discord Guild: [Add VoiceState Bot](https://discord.com/api/oauth2/authorize?client_id=954772647575703602&permissions=0&scope=bot)
* Grab the state by fetching https://discordbot.f-brinker.de/voice-state/states/userId123.json
  * Replace userId123 with your Discord userId

### Where can I find my Discord userId?
See https://techswift.org/2020/04/22/how-to-find-your-user-id-on-discord/

## Host your own!
You can host your own bot by building the project on your own or by using the pre-built image `fbrinker/discordbot-voice-state`.

You need to create your own Discord application and bot. You need the Bot Token below. Replace `yourBotToken` with your actual token.

### Examle Docker-Compose
```
discordbot-voice-state:
  container_name: discordbot-voice-state
  image: fbrinker/discordbot-voice-state
  restart: always
  environment:
    - "BOT_TOKEN=yourBotToken"
```

## Contribute
Feel free to add Pull-Request @ https://git.f-brinker.de/fbrinker/discordbot-voice-state
